# (C) Copyright 2008 Brian Fisher, Zach Young, James Paige
# This is Free Software released under the terms of the GPL
# Created for the Pyweek May 2008 competition: "ROBOTS!"

from locals import *

#------------------------------------------------------------------------------

class CompassPoint(object):

  def __init__(self, name, axis, sign, key):
    self.name = name
    self.axis = axis
    self.sign = sign
    self.key = key

  def pressed(self, event):
    return event.key == self.key

  def go(self, vector, distance=1):
    vector[self.axis] += distance * self.sign

  def set(self, vector, value=1):
    vector[self.axis] = value * self.sign

  def get(self, vector):
    return vector[self.axis] * self.sign

#------------------------------------------------------------------------------

class Compass(object):

  def __init__(self):
    self.north = CompassPoint("north", 1, 1, K_UP)
    self.east  = CompassPoint("east",  0, 1, K_RIGHT)
    self.south = CompassPoint("south", 1, -1, K_DOWN)
    self.west  = CompassPoint("west",  0, -1, K_LEFT)
    self.around = [self.north, self.east, self.south, self.west]

  def __iter__(self):
    self._i = -1
    return self

  def next(self):
    self._i += 1
    if self._i >= len(self.around):
      raise StopIteration
    return self.around[self._i]
    

#------------------------------------------------------------------------------

